/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGoogleProjectIamCustomRolesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/data-sources/google_project_iam_custom_roles#id DataGoogleProjectIamCustomRoles#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/data-sources/google_project_iam_custom_roles#project DataGoogleProjectIamCustomRoles#project}
    */
    readonly project?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/data-sources/google_project_iam_custom_roles#show_deleted DataGoogleProjectIamCustomRoles#show_deleted}
    */
    readonly showDeleted?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/data-sources/google_project_iam_custom_roles#view DataGoogleProjectIamCustomRoles#view}
    */
    readonly view?: string;
}
export interface DataGoogleProjectIamCustomRolesRoles {
}
export declare function dataGoogleProjectIamCustomRolesRolesToTerraform(struct?: DataGoogleProjectIamCustomRolesRoles): any;
export declare function dataGoogleProjectIamCustomRolesRolesToHclTerraform(struct?: DataGoogleProjectIamCustomRolesRoles): any;
export declare class DataGoogleProjectIamCustomRolesRolesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataGoogleProjectIamCustomRolesRoles | undefined;
    set internalValue(value: DataGoogleProjectIamCustomRolesRoles | undefined);
    get deleted(): cdktf.IResolvable;
    get description(): string;
    get id(): string;
    get name(): string;
    get permissions(): string[];
    get roleId(): string;
    get stage(): string;
    get title(): string;
}
export declare class DataGoogleProjectIamCustomRolesRolesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataGoogleProjectIamCustomRolesRolesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/data-sources/google_project_iam_custom_roles google_project_iam_custom_roles}
*/
export declare class DataGoogleProjectIamCustomRoles extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "google_project_iam_custom_roles";
    /**
    * Generates CDKTF code for importing a DataGoogleProjectIamCustomRoles resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataGoogleProjectIamCustomRoles to import
    * @param importFromId The id of the existing DataGoogleProjectIamCustomRoles that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/data-sources/google_project_iam_custom_roles#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataGoogleProjectIamCustomRoles to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/data-sources/google_project_iam_custom_roles google_project_iam_custom_roles} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGoogleProjectIamCustomRolesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataGoogleProjectIamCustomRolesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _roles;
    get roles(): DataGoogleProjectIamCustomRolesRolesList;
    private _showDeleted?;
    get showDeleted(): boolean | cdktf.IResolvable;
    set showDeleted(value: boolean | cdktf.IResolvable);
    resetShowDeleted(): void;
    get showDeletedInput(): boolean | cdktf.IResolvable | undefined;
    private _view?;
    get view(): string;
    set view(value: string);
    resetView(): void;
    get viewInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
