/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GoogleBeyondcorpSecurityGatewayIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#id GoogleBeyondcorpSecurityGatewayIamMember#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#location GoogleBeyondcorpSecurityGatewayIamMember#location}
    */
    readonly location?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#member GoogleBeyondcorpSecurityGatewayIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#project GoogleBeyondcorpSecurityGatewayIamMember#project}
    */
    readonly project?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#role GoogleBeyondcorpSecurityGatewayIamMember#role}
    */
    readonly role: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#security_gateway_id GoogleBeyondcorpSecurityGatewayIamMember#security_gateway_id}
    */
    readonly securityGatewayId: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#condition GoogleBeyondcorpSecurityGatewayIamMember#condition}
    */
    readonly condition?: GoogleBeyondcorpSecurityGatewayIamMemberCondition;
}
export interface GoogleBeyondcorpSecurityGatewayIamMemberCondition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#description GoogleBeyondcorpSecurityGatewayIamMember#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#expression GoogleBeyondcorpSecurityGatewayIamMember#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#title GoogleBeyondcorpSecurityGatewayIamMember#title}
    */
    readonly title: string;
}
export declare function googleBeyondcorpSecurityGatewayIamMemberConditionToTerraform(struct?: GoogleBeyondcorpSecurityGatewayIamMemberConditionOutputReference | GoogleBeyondcorpSecurityGatewayIamMemberCondition): any;
export declare function googleBeyondcorpSecurityGatewayIamMemberConditionToHclTerraform(struct?: GoogleBeyondcorpSecurityGatewayIamMemberConditionOutputReference | GoogleBeyondcorpSecurityGatewayIamMemberCondition): any;
export declare class GoogleBeyondcorpSecurityGatewayIamMemberConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): GoogleBeyondcorpSecurityGatewayIamMemberCondition | undefined;
    set internalValue(value: GoogleBeyondcorpSecurityGatewayIamMemberCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member google_beyondcorp_security_gateway_iam_member}
*/
export declare class GoogleBeyondcorpSecurityGatewayIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_beyondcorp_security_gateway_iam_member";
    /**
    * Generates CDKTF code for importing a GoogleBeyondcorpSecurityGatewayIamMember resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GoogleBeyondcorpSecurityGatewayIamMember to import
    * @param importFromId The id of the existing GoogleBeyondcorpSecurityGatewayIamMember that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GoogleBeyondcorpSecurityGatewayIamMember to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.34.1/docs/resources/google_beyondcorp_security_gateway_iam_member google_beyondcorp_security_gateway_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GoogleBeyondcorpSecurityGatewayIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: GoogleBeyondcorpSecurityGatewayIamMemberConfig);
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    resetLocation(): void;
    get locationInput(): string | undefined;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _securityGatewayId?;
    get securityGatewayId(): string;
    set securityGatewayId(value: string);
    get securityGatewayIdInput(): string | undefined;
    private _condition;
    get condition(): GoogleBeyondcorpSecurityGatewayIamMemberConditionOutputReference;
    putCondition(value: GoogleBeyondcorpSecurityGatewayIamMemberCondition): void;
    resetCondition(): void;
    get conditionInput(): GoogleBeyondcorpSecurityGatewayIamMemberCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
